summaryrefslogtreecommitdiff
path: root/helpers/source_usb
diff options
context:
space:
mode:
Diffstat (limited to 'helpers/source_usb')
-rwxr-xr-xhelpers/source_usb139
1 files changed, 139 insertions, 0 deletions
diff --git a/helpers/source_usb b/helpers/source_usb
new file mode 100755
index 0000000..6065382
--- /dev/null
+++ b/helpers/source_usb
@@ -0,0 +1,139 @@
+#!/bin/sh
+
+# lh_source_usb(1) - build source usb image
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'build source image')"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+if [ "${LH_SOURCE}" != "true" ]
+then
+ exit 0
+fi
+
+if ! In_list usb-hdd "${LH_SOURCE_IMAGES}"
+then
+ exit 0
+fi
+
+Echo_message "Begin building source usb image..."
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/source_debian
+
+# Checking stage file
+Check_stagefile .stage/source_usb
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+# Checking depends
+Check_package chroot/sbin/mkdosfs dosfstools
+Check_package chroot/sbin/parted parted
+
+# Installing depends
+Install_package
+
+# Remove old source
+if [ -f source.img ]
+then
+ rm -f source.img
+fi
+
+# Everything which comes here needs to be cleaned up,
+DU_DIM="$(du -ms source | cut -f1)"
+REAL_DIM="$(Calculate_partition_size ${DU_DIM} ${LH_BINARY_FILESYSTEM})"
+dd if=/dev/zero of=source.img bs=1024k count=0 seek=${REAL_DIM}
+FREELO="$(${LH_LOSETUP} -f)"
+if [ ! -b chroot/${FREELO} ]
+then
+ MAKEDEV="true"
+
+ mv chroot/dev chroot/dev.tmp
+ find /dev | cpio -dmpu chroot
+fi
+
+case "${LH_BINARY_FILESYSTEM}" in
+ ext2|ext3)
+ PARTITION_TYPE="ext2"
+ ;;
+
+ fat16|fat32)
+ PARTITION_TYPE="${LH_BINARY_FILESYSTEM}"
+ ;;
+
+ *)
+ Echo_error "Unsupported binary filesystem %s" "${LH_BINARY_FILESYSTEM}"
+ exit 1
+ ;;
+esac
+
+Echo_warning "!!! The following error/warning messages can be ignored !!!"
+Losetup $FREELO source.img 0
+Chroot chroot "parted -s ${FREELO} mklabel msdos" || true
+Chroot chroot "parted -s ${FREELO} mkpart primary ${PARTITION_TYPE} 0.0 100%" || true
+Chroot chroot "parted -s ${FREELO} set 1 lba off" || true
+sleep 1
+${LH_LOSETUP} -d ${FREELO}
+
+Losetup $FREELO source.img 1
+
+case "${LH_BINARY_FILESYSTEM}" in
+ ext2|ext3)
+ MKFS="${LH_BINARY_FILESYSTEM}"
+ MKFS_OPTIONS="-L DEBIAN_LIVE -m 0"
+ ;;
+
+ fat16)
+ MKFS="vfat"
+ MKFS_OPTIONS="-F 16 -n DEBIAN_LIVE"
+ ;;
+
+ fat32)
+ MKFS="vfat"
+ MKFS_OPTIONS="-F 32 -n DEBIAN_LIVE"
+ ;;
+esac
+
+Chroot chroot "mkfs.${MKFS} ${MKFS_OPTIONS} ${FREELO}"
+
+mkdir -p source.tmp
+${LH_ROOT_COMMAND} mount ${FREELO} source.tmp
+cp -r source/* source.tmp
+${LH_ROOT_COMMAND} umount source.tmp
+rmdir source.tmp
+sleep 1
+${LH_LOSETUP} -d ${FREELO}
+Echo_warning "!!! The above error/warning messages can be ignored !!!"
+
+if [ -n "${MAKEDEV}" ]
+then
+ rm -rf chroot/dev
+ mv chroot/dev.tmp chroot/dev
+fi
+
+# Removing depends
+Remove_package
+
+# Creating stage file
+Create_stagefile .stage/source_usb